#!/bin/bash
# treeadmin.cgi 
# created and copyrighted: 19 Jan 11
# author: Evsiz (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

ROOT=fanghorn
FTOPICS=$ROOT/heart/topics
LOG=write.log
TARBALL_DIR=data/private  # treeadmin.cgi?archive 
SELF="69.144.89.44 x"
if [ -f .local  ]; then SELF="127.0.0.1 x";  fi

REQUEST=`echo  "$REQUEST_URI" | cut -d"?" -f2`
PARAM=`echo  "$REQUEST" | cut -d"=" -f1`
VALUE=`echo  "$REQUEST" | cut -d"=" -f2 | sed 's/%2F/\//g' | tr -d .\*`

# Validate IP
REMOTE=$HTTP_X_CLUSTER_CLIENT_IP 
if [ "$REMOTE" == "" ]; then REMOTE=$REMOTE_ADDR ; fi
OK=`echo $SELF | awk 'BEGIN { RS = " " }; \
    {  if ( index( "'$REMOTE'", $0 ) == 1 ) { print "okay"; exit } }'`
if [ "$OK" != "okay" ]; then PARAM=orc ; fi


echo "Content-Type: text/html

<h4>treeadmin.cgi</h4>"

if [ "$PARAM" == "orc" ]; then
    echo "No Orcs Allowed"
elif [ "$PARAM" == "warn" ]; then
    echo "warning "$VALUE
    PAGE=$ROOT/$VALUE
    CONTENT=`cat $PAGE`
    echo "DELETE
Page content outside site guidelines and marked for deletion.
Please play nice and fix this page. (See the-rules)
" > $PAGE
    echo $CONTENT >> $PAGE
elif [ "$PARAM" == "delete" ]; then
    VALUE=`echo $VALUE | tr -d "/?*"`
    rm $ROOT/$VALUE && echo "<br>deleted "$VALUE || echo "<br>failed: "$VALUE 
elif [ "$PARAM" == "purge" ]; then
    chmod 644 treebeard.cgi  # LOCK
    RESULT=`grep -lr DELETE $ROOT/*`
    if [ $? -eq 0 ]; then
	for entry in $RESULT; do
	    ROOTPAGE=`echo $entry | tr -d [:digit:]`
	    if [ "$entry" != $ROOTPAGE ]; then # delete if not in ROOT
		rm $entry && echo "<br>removed: "$entry || echo "<br>failed: "$entry
	    fi
	    LEAF=`echo $entry | tr -d _`
	    if [ "$entry" != $LEAF ]; then # if branch page, delete dir
		DIR=`dirname $entry`
		rm -r $DIR && echo "<br>removed: "$DIR || echo "<br>failed: "$DIR
		TOPICS=`cat $FTOPICS`
		echo "<br> removing topics entry for "$DIR
		rm $FTOPICS
		echo $TOPICS | awk 'BEGIN { FS = ":" ; RS = " "}; \
                {  if ( index( "'$DIR'", $2 ) == 0 ) print $0  }' >> $FTOPICS
	    fi
	    ls -lR $ROOT > _cgitmp # remove empty dirs
	    ORPHANS=`cat _cgitmp | sed -n ' /'$ROOT'/ { h }; /total 0/  { x; p }'`
	    for orphan in $ORPHANS; do
		orphan=`echo $orphan | tr -d :`
		rm -r $orphan && echo "<br>removed: "$orphan || "<br>failure: "$orphan
	    done
	    rm _cgitmp
	    
	done
    else
	echo "<h4>No files to purge.</h4>"
    fi  
    chmod 755 treebeard.cgi  # UNLOCK
    
elif [ "$PARAM" == "archive" ]; then
	tar cjf $TARBALL_DIR/treebeard.tar.bz2 $ROOT && \
		echo "treebeard archived" || echo "archive failed"
else
	echo "<title>"$LOG"</title>
	<h4>"$LOG"</h4>
	`date +%c`<hr><pre>"
	echo "   - end of data - " >> $LOG
	cat $LOG && rm $LOG
	echo "</pre>
<p><a href=/cgi-bin/treeadmin.cgi?archive>Archive</a> all entries?
<p><a href=/cgi-bin/treeadmin.cgi?purge>Purge</a> all entries marked for deletion?"
fi
