#!/bin/bash
# tree_img.cgi 
# created and copyrighted: 7 Feb 11
# author: Evsiz (evsiz@this-voice.org)
# The author releases this file under the GNU GPL
# license. See GNU's COPYING file for specifics.
#

ROOT=fanghorn
RTPATH=`pwd`/$ROOT
TFILE=$RTPATH/heart/topics # not in a dir with a _rootpage
SOURCES="picasaweb photobucket flickr nosource x"
BANNED_IPS="x"  # space between IPs - keep x at end of list
IMG_PATH=/img

echo "Content-Type: text/html

"

# banned ips
REMOTE=$HTTP_X_CLUSTER_CLIENT_IP 
if [ "$REMOTE" == "" ]; then REMOTE=$REMOTE_ADDR; fi
BANNED=`echo $BANNED_IPS | awk 'BEGIN { RS = " " }; { \
    if ( index( "'$REMOTE'", $0 ) == 1 ) { print "banned"; exit } }'`
if [ "$BANNED" == "banned" ]; then
    echo "No Orcs Allowed"
    exit
fi

# methods

decode () {
    arg=`echo $1 | awk '{ 
       gsub(/\%0D\%0A/, "\r") ;
       gsub(/\%0d\%0a/, "\r") ;
       gsub(/\x2B/, " ") ; 
       gsub(/\x2b/, " ") ; 
       print
    }'`
    i="0"
    while [ "$i" -lt ${#arg} ]; do
        c0=${arg:$i:1}
        if [ "x$c0" = "x%" ]; then
            c1=${arg:$((i+1)):1}
            c2=${arg:$((i+2)):1}
            printf "\x$c1$c2"
            i=$((i+3))
        else
            echo -n "$c0"
            i=$((i+1))
        fi
    done

}

pwd2dir () {
    if [ "$1" == "" ]; then
	echo "none"
	return
    fi
    cat $TFILE | awk 'BEGIN { FS = ":" } ; \
        { if ($1 ~ "'$1'") { print $2 ; exit }}'
}

parse_val () {
    echo $1 | awk 'BEGIN { RS = "&" } ; \
	{ if (index($0, "'$2'") == 1) { split($0, tmp, "="); print tmp[2]; exit; }};'
}

err_pg () {
    echo "<center><hr>LOST IN FANGHORN FOREST.<p>"$1"<br>
          Image Link Cancelled.<hr></center>"
    exit
}

# main
REQUEST=`echo  "$REQUEST_URI" | cut -d"?" -f2`
LINK=$(decode $(parse_val $REQUEST "link"))
PAGE=$(parse_val $REQUEST "page")
TPSWD=$(parse_val $REQUEST "tpswd")
MONTH=$(parse_val $REQUEST "month")
# validate month
if [ "$MONTH" != `date +%m` ]; then
    err_pg "Month incorrect."
fi
# validate src and change nosource => img_path
IS_SRC=`echo $SOURCES | awk 'BEGIN { RS = " " }; { \
    if ( index( "'$LINK'", $0 ) != 0 ) { print "ok"; exit } }'`
if [ "$IS_SRC" != "ok" ]; then
    err_pg "Image not from accepted source."
fi
LINK=`echo $LINK | awk '{gsub("nosource", "'$IMG_PATH'"); print $0}'`
# validate page
TDIR=$(pwd2dir $TPSWD)
FNAME=$RTPATH/$TDIR/$PAGE
TAGS=`grep \<img $FNAME`
if [ ! -f $FNAME ]; then
    err_pg "No page called "$PAGE" in directory "$TDIR.
elif [ -n "$TAGS" ]; then 
    err_pg $PAGE" already contains HTML."
fi
# inject image link
cp $FNAME trmg_$$
echo "<img src=\""$LINK"\"><p>" > $FNAME
awk '{print $0}' <trmg_$$ >> $FNAME
rm trmg_$$
# success response
echo "Image injected into "$PAGE"
<p><a href=/cgi-bin/treebeard.cgi?page="$TDIR/$PAGE" >View Page</a>"
# admin links
		echo " <p>
<img src=\""$LINK"\"> - 
<a href=/cgi-bin/treeadmin.cgi?warn="$TDIR/$PAGE">warn</a> -
<a href=/cgi-bin/treeadmin.cgi?delete="$TDIR/$PAGE">delete</a><br>" >> `pwd`/write.log
